#include <stdio.h>
#include <stdlib.h>
double ** vyroba_2D(int r, int s)
{
    int i;
    double **p_X;
    p_X=(double **)malloc(r*sizeof(double *));
    for(i=0; i<r; i++)
        p_X[i]=(double *)malloc(s*sizeof(double));
    return(p_X);
}
void uvolni_2D(double **p_X, int r, int s)
{
    int i;
    for(i=0; i<r; i++)
        free((void *)p_X[i]);
    free((void **)p_X);
}
void zadej_2D(double **p_X, int r, int s)
{
    int i,j;
    for(i=0; i<r; i++)
    {
        for(j=0; j<s; j++)
        {
            printf("Zadej prvek [%d][%d]: ",i+1,j+1);
            scanf("%lf",&(p_X[i][j]));
        }
    }
}
void tisk_2D(double **p_X, int r, int s)
{
    int i,j;
    for(i=0; i<r; i++)
    {
        for(j=0; j<s; j++)
        {
            printf("%10.2g\t",p_X[i][j]);
        }
        printf("\n");
    }
}
int main()
{
    double **p_A;
    int r, s;
    do
    {
        printf("Zadej pocet radku a sloupcu:\n");
        scanf("%d %d",&r,&s);
    }while((r<=0)||(s<=0));
    p_A=vyroba_2D(r,s);
    zadej_2D(p_A,r,s);
    tisk_2D(p_A,r,s);
    uvolni_2D(p_A,r,s);

    return 0;
}
